UPDATE APPLICATIONS SET VERSION=3.9 WHERE ID=$APP_ID{};

DROP TABLE CONFIGURATION;
CREATE TABLE CONFIGURATION(
POTERMS VARCHAR(255) NULL,
NEXTREQNO INT NULL,
NEXTPONO INT NULL,
NEXTGRNO INT NULL,
NEXTBARCODE INT NULL,
COUNTRY VARCHAR(8) NULL,
FORMATINTEGER VARCHAR(20) NULL,
FORMATDOUBLE VARCHAR(20) NULL,
FORMATCURRENCY VARCHAR(20) NULL,
FORMATPERCENT VARCHAR(20) NULL,
FORMATDATE VARCHAR(45) NULL,
FORMATTIME VARCHAR(45) NULL,
FORMATDATETIME VARCHAR(45) NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
INSERT INTO CONFIGURATION VALUES('Supplier shall issue accurate invoices to Buyer for Goods.\nShipments must be made to meet the date specified in the Purchase Order.', 1, 1, 1, 10001, 'en_US', '#0', '#0.0', '#0.00', '#0%', 'd-m-Y', 'h:i', 'd-m-Y h:i');

CREATE TABLE ACCOUNTS(
    ID VARCHAR(255) NOT NULL,
    ACCOUNT_NAME VARCHAR(255) NOT NULL,
    ACCOUNT_NUMBER VARCHAR(255),
    INITIAL_BALANCE DOUBLE NOT NULL,
    AVAILABLE_BALANCE DOUBLE NOT NULL,
    PRIMARY KEY (ID) 
) ENGINE=INNODB DEFAULT CHARSET=UTF8;
INSERT INTO ACCOUNTS (ID, ACCOUNT_NAME, ACCOUNT_NUMBER, INITIAL_BALANCE, AVAILABLE_BALANCE) VALUES ('PURCHASE', 'PURCHASE', 'PURCHASE', '0', '0');
INSERT INTO ACCOUNTS (ID, ACCOUNT_NAME, ACCOUNT_NUMBER, INITIAL_BALANCE, AVAILABLE_BALANCE) VALUES ('SALE', 'SALE', 'SALE', '0', '0');

CREATE TABLE PAYMENTHEADS (
  ID VARCHAR(255) NOT NULL,
  PAYMENTHEAD VARCHAR(255) NOT NULL,
  PRIMARY KEY (ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
INSERT INTO PAYMENTHEADS (ID, PAYMENTHEAD) VALUES ('DEPOSIT', 'DEPOSIT');
INSERT INTO PAYMENTHEADS (ID, PAYMENTHEAD) VALUES ('PURCHASE', 'PURCHASE');
INSERT INTO PAYMENTHEADS (ID, PAYMENTHEAD) VALUES ('PURCHASERETURN', 'PURCHASE RETURN');

CREATE TABLE TRANSACTIONS (
  ID VARCHAR(255) NOT NULL,
  TRANSACTION_DATE DATE NOT NULL,
  TRANSACTION_TYPE_ID SMALLINT NOT NULL,
-- 0. Deposit 1. Withdrawal
  ACCOUNT_ID VARCHAR(255) NOT NULL,
  PAYMENTHEAD_ID VARCHAR(255) NOT NULL,
  AMOUNT DOUBLE NOT NULL,
  COMMENTS TEXT,
  STATUS SMALLINT NOT NULL,
-- 0-Created, 1-Approved, 2-Rejected
  CREATED DATETIME NOT NULL,
  CREATED_BY VARCHAR(255) NOT NULL,
  APPROVED DATETIME NOT NULL,
  APPROVED_BY VARCHAR(255) NOT NULL,
  PRIMARY KEY (ID),
  CONSTRAINT TRANSACTIONS_FK_1 FOREIGN KEY (ACCOUNT_ID) REFERENCES ACCOUNTS(ID),
  CONSTRAINT TRANSACTIONS_FK_2 FOREIGN KEY (PAYMENTHEAD_ID) REFERENCES PAYMENTHEADS(ID),
  CONSTRAINT TRANSACTIONS_FK_3 FOREIGN KEY (CREATED_BY) REFERENCES PEOPLE(ID),
  CONSTRAINT TRANSACTIONS_FK_4 FOREIGN KEY (APPROVED_BY) REFERENCES PEOPLE(ID)
) ENGINE=INNODB DEFAULT CHARSET=UTF8;

ALTER TABLE PURCHASEINVOICELINES DROP COLUMN UOM, DROP COLUMN TAXAMOUNT;
ALTER TABLE PURCHASEINVOICELINES MODIFY COLUMN ID VARCHAR(255) NOT NULL;
ALTER TABLE PURCHASEINVOICELINES DROP FOREIGN KEY PIL_PI_FK_1;
ALTER TABLE PURCHASEINVOICELINES MODIFY COLUMN PIID VARCHAR(255) NOT NULL;
ALTER TABLE PURCHASEINVOICELINES ADD COLUMN TAXID VARCHAR(255) NOT NULL;
UPDATE PURCHASEINVOICELINES SET TAXID='000';
ALTER TABLE PURCHASEINVOICELINES ADD CONSTRAINT PIL_TAX_FK_3 FOREIGN KEY (TAXID) REFERENCES TAXES(ID);
ALTER TABLE PURCHASEINVOICE MODIFY COLUMN ID VARCHAR(255) NOT NULL;
ALTER TABLE PURCHASEINVOICELINES ADD CONSTRAINT PIL_PI_FK_1 FOREIGN KEY (PIID) REFERENCES PURCHASEINVOICE(ID);
ALTER TABLE PURCHASEINVOICE DROP COLUMN REVISION, DROP COLUMN TAXAMOUNT, DROP COLUMN TOTALAMOUNT;
ALTER TABLE PURCHASEINVOICE DROP FOREIGN KEY PI_EMP_FK_2;
ALTER TABLE PURCHASEINVOICE CHANGE UPDATEDBY APPROVEDBY VARCHAR(255) DEFAULT NULL;
ALTER TABLE PURCHASEINVOICE CHANGE UPDATEDDATE APPROVEDDATE TIMESTAMP;
ALTER TABLE PURCHASEINVOICE ADD CONSTRAINT PI_EMP_FK_2 FOREIGN KEY (APPROVEDBY) REFERENCES people(ID);
ALTER TABLE PURCHASEINVOICE CHANGE TERMS COMMENTS TEXT;

CREATE TABLE PURCHASEINVOICETAXES (
    ID VARCHAR(255) NOT NULL,
    PIID VARCHAR(255) NOT NULL,
    TAXID VARCHAR(255) NOT NULL,
    BASEAMOUNT DOUBLE NOT NULL,
    TAXAMOUNT DOUBLE NOT NULL,
    PRIMARY KEY (ID),
    CONSTRAINT PILT_PI_FK_1 FOREIGN KEY (PIID) REFERENCES PURCHASEINVOICE(ID),
    CONSTRAINT PILT_TAX_FK_2 FOREIGN KEY (TAXID) REFERENCES TAXES(ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE PURCHASEINVOICE_PAYMENTS (
  ID VARCHAR(255) NOT NULL,
  PURCHASEINVOICE_ID VARCHAR(255) NOT NULL,
  TRANSACTION_ID VARCHAR(255) NOT NULL,
  PRIMARY KEY (ID),
  CONSTRAINT PURCHASE__FK_1 FOREIGN KEY (PURCHASEINVOICE_ID) REFERENCES PURCHASEINVOICE(ID),
  CONSTRAINT PPAYMENTS_FK_2 FOREIGN KEY (TRANSACTION_ID) REFERENCES TRANSACTIONS(ID)
) ENGINE=INNODB DEFAULT CHARSET=UTF8;